import logging
import uuid
from contextlib import asynccontextmanager

import logfire
from fastapi import FastAPI
from fastapi.responses import StreamingResponse
from pydantic import BaseModel

from . import services
from .config import config

logger = logging.getLogger(__name__)


@asynccontextmanager
async def lifespan(_: FastAPI):
    await config.init_mongo_db()
    yield


app = FastAPI(lifespan=lifespan)
logfire.instrument_fastapi(app)


class Message(BaseModel):
    conversation_id: uuid.UUID
    prompt: str


@app.post("/api/v1/conversation")
async def create_conversation():
    conversation_id = uuid.uuid4()
    await services.create_conversation(conversation_id)
    return {"conversation_id": conversation_id}


@app.post("/api/v1/message")
async def send(message: Message, stream: bool = False):
    if stream is True:

        def b64_sse(func):
            async def wrapper(*args, **kwargs):
                async for chunk in func(*args, **kwargs):
                    content = chunk.model_dump_json()
                    data = f"data: {content}\n\n"
                    logger.info(f"Yielding Event: {data}")
                    yield data

            return wrapper

        sse_stream = b64_sse(services.stream)
        generator = sse_stream(message.prompt, message.conversation_id)
        return StreamingResponse(generator, media_type="text/event-stream")
    else:
        response = await services.generate(message.prompt, message.conversation_id)
        return response


@app.get("/")
async def health():
    return {"status": "ok"}
